/*  Emacs style mode select   -*- C++ -*-  */
/* ----------------------------------------------------------------------------- */
/*  */
/*  $Id:$ */
/*  */
/*  Copyright (C) 1993-1996 by id Software, Inc. */
/*  */
/*  This source is available for distribution and/or modification */
/*  only under the terms of the DOOM Source Code License as */
/*  published by id Software. All rights reserved. */
/*  */
/*  The source is distributed in the hope that it will be useful, */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of */
/*  FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License */
/*  for more details. */
/*  */
/*  DESCRIPTION: */
/* 	Gamma correction LUT. */
/* 	Functions to draw patches (by post) directly to screen. */
/* 	Functions to blit a block to the screen. */
/*  */
/* ----------------------------------------------------------------------------- */


#ifndef __V_VIDEO__
#define __V_VIDEO__

#include "doomdef.h"

/*  */
/*  VIDEO */
/*  */

#define CENTERY			(SCREENHEIGHT/2)


/*  Screen 0 is the screen updated by I_Update screen. */
/*  Screen 1 is an extra buffer. */



extern	byte*		screen;

extern  int	dirtybox[4];

extern	byte	gammatable[5][256];
extern	int	usegamma;



/*  Allocates buffer screens, call before R_Init. */
void V_Init (void);

extern void (*V_DrawPatch) (int x,int y,patch_t *patch);
extern void (*V_DrawFuzzPatch) (int x, int y, patch_t *patch);
extern void (*V_DrawShadowedPatch) (int x, int y, patch_t *patch);
void V_DrawRawScreen(byte *raw);

void V_DrawShadowedPatch8(int x, int y, patch_t *patch);

void V_DrawFuzzPatch8 (int x,int y,patch_t *patch);
void V_DrawFuzzPatch16 (int x,int y,patch_t *patch);
void V_DrawFuzzPatch24 (int x,int y,patch_t *patch);
void V_DrawFuzzPatch32 (int x,int y,patch_t *patch);

void
V_CopyRect
( int		srcx,
  int		srcy,
  int		srcscrn,
  int		width,
  int		height,
  int		destx,
  int		desty,
  int		destscrn );

void
V_DrawPatch8
( int		x,
  int		y,
  patch_t*	patch);

void
V_DrawPatch16
( int		x,
  int		y,
  patch_t*	patch);

void
V_DrawPatch24
( int		x,
  int		y,
  patch_t*	patch);

void
V_DrawPatch32
( int		x,
  int		y,
  patch_t*	patch);

/*  Draw a linear block of pixels into the view buffer. */
void
V_DrawBlock
( int		x,
  int		y,
  int		scrn,
  int		width,
  int		height,
  byte*		src );


void
V_MarkRect
( int		x,
  int		y,
  int		width,
  int		height );

#endif
