/*  F_finale.c */

#include <ctype.h>

#include "doomdef.h"
#include "soundst.h"
#include "i_video.h"
#include "v_video.h"

int             finalestage;            /*  0 = text, 1 = art screen */
int             finalecount;

#define TEXTSPEED       3
#define TEXTWAIT        250

char    *e1text = E1TEXT;
char    *e2text = E2TEXT;
char    *e3text = E3TEXT;
char    *e4text = E4TEXT;
char    *e5text = E5TEXT;
char    *finaletext;
char    *finaleflat;

int FontABaseLump;

extern boolean automapactive;
extern boolean viewactive;

extern void D_StartTitle(void);

/*
=======================
=
= F_StartFinale
=
=======================
*/

void F_StartFinale (void)
{
	gameaction = ga_nothing;
	gamestate = GS_FINALE;
	viewactive = false;
	automapactive = false;
	players[consoleplayer].messageTics = 1;
	players[consoleplayer].message = NULL;

	switch(gameepisode)
	{
		case 1:
			finaleflat = "FLOOR25";
			finaletext = e1text;
			break;
		case 2:
			finaleflat = "FLATHUH1";
			finaletext = e2text;
			break;
		case 3:
			finaleflat = "FLTWAWA2";
			finaletext = e3text;
			break;
		case 4:
			finaleflat = "FLOOR28";
			finaletext = e4text;
			break;
		case 5:
			finaleflat = "FLOOR08";
			finaletext = e5text;
			break;
	}

	finalestage = 0;
	finalecount = 0;
	FontABaseLump = W_GetNumForName("FONTA_S")+1;

	S_StartSong(mus_cptd, true);
}

boolean F_Responder (event_t *event)
{
	if(event->type != ev_keydown)
	{
		return false;
	}

	if(finalestage == 1 && gameepisode == 2)
	{ /*  we're showing the water pic, make any key kick to demo mode */
		finalestage++;
		/* memset((byte *)0xa0000, 0, SCREENWIDTH*SCREENHEIGHT); */
		memset(screen, 0, SCREENWIDTH*SCREENHEIGHT*pixel_size);
		I_SetPalette(W_CacheLumpName("PLAYPAL", PU_CACHE));
		return true;
	}

	return false;
}


/*
=======================
=
= F_Ticker
=
=======================
*/

void F_Ticker (void)
{
	finalecount++;
	if (!finalestage && finalecount>strlen (finaletext)*TEXTSPEED + TEXTWAIT)
	{
		finalecount = 0;
		if(!finalestage)
		{
			finalestage = 1;
		}

	}
}


/*
=======================
=
= F_TextWrite
=
=======================
*/

/* #include "HU_stuff.h" */
/* extern        patch_t *hu_font[HU_FONTSIZE]; */

void F_TextWrite (void)
{
	byte    *src, *dest;
	int             x,y;
	int             count;
	char    *ch;
	int             c;
	int             cx, cy;
	patch_t *w;

	byte *src1;
	unsigned long	*destsrc32;
	unsigned short	*destsrc;

/*  */
/*  erase the entire screen to a tiled background */
/*  */
	src = W_CacheLumpName(finaleflat, PU_CACHE);

	switch (pixel_size)
	{
		case 1:
			dest = screen;
			for (y=0 ; y<SCREENHEIGHT ; y++)
			{
				for (x=0 ; x<SCREENWIDTH/64 ; x++)
				{
					memcpy (dest, src+((y&63)<<6), 64);
					dest += 64;
				}
				if (SCREENWIDTH&63)
				{
					memcpy (dest, src+((y&63)<<6), SCREENWIDTH&63);
					dest += (SCREENWIDTH&63);
				}
			}
			break;
		case 2:
			destsrc = (unsigned short *) screen; 
	 
			for (y=0 ; y<SCREENHEIGHT ; y++) 
			{ 
				unsigned short *dest1;

				src1 = src + ((y & 63) << 6);
				dest1 = destsrc;

				for (x=0; x<SCREENWIDTH ; x++)
				{
					*dest1++ = truecolor_palette[ src1[x & 63] ];
				}
				destsrc += SCREENWIDTH;
    			} 
			break;
		case 3:
			dest=screen;
			for (y=0 ; y<SCREENHEIGHT ; y++) 
			{ 
				byte	*dest1;

				src1 = src + ((y & 63) << 6);
				dest1 = dest;

				for (x=0; x<SCREENWIDTH ; x++)
				{
					unsigned long couleur;

					couleur = truecolor_palette[ src1[x & 63] ];

					*dest1++ = couleur;
					*dest1++ = couleur >> 8;
					*dest1++ = couleur >> 16;			
				}
				dest += SCREENWIDTH*3;
			} 
			break;
		case 4:
			destsrc32 = (unsigned long *) screen; 
	 
			for (y=0 ; y<SCREENHEIGHT ; y++) 
			{ 
				unsigned long *dest1;

				src1 = src + ((y & 63) << 6);
				dest1 = destsrc32;

				for (x=0; x<SCREENWIDTH ; x++)
				{
					*dest1++ = truecolor_palette[ src1[x & 63] ];
				}
				destsrc32 += SCREENWIDTH;
    			} 
			break;
	}

/*  */
/*  draw some of the text onto the screen */
/*  */
	cx = 20;
	cy = 5;
	ch = finaletext;

	count = (finalecount - 10)/TEXTSPEED;
	if (count < 0)
		count = 0;
	for ( ; count ; count-- )
	{
		c = *ch++;
		if (!c)
			break;
		if (c == '\n')
		{
			cx = 20;
			cy += 9;
			continue;
		}

		c = toupper(c);
		if (c < 33)
		{
			cx += 5;
			continue;
		}

		w = W_CacheLumpNum(FontABaseLump+c-33, PU_CACHE);
		if (cx+w->width > SCREENWIDTH)
			break;
		V_DrawPatch(cx, cy, w);
		cx += w->width;
	}

}

void (*F_DrawPatchCol) ();


void F_DrawPatchCol8 (int x, patch_t *patch, int col)
{
	column_t        *column;
	byte            *source, *dest, *desttop;
	int                     count;

	column = (column_t *)((byte *)patch + LONG(patch->columnofs[col]));
	desttop = screen+x;

/*  step through the posts in a column */

	while (column->topdelta != 0xff )
	{
		source = (byte *)column + 3;
		dest = desttop + column->topdelta*SCREENWIDTH;
		count = column->length;

		while (count--)
		{
			*dest = *source++;
			dest += SCREENWIDTH;
		}
		column = (column_t *)(  (byte *)column + column->length+ 4 );
	}
}

void
F_DrawPatchCol16
( int		x,
  patch_t*	patch,
  int		col )
{
    column_t*	column;
    byte*	source;
	unsigned short	*desttop,*dest;
    int		count;
	
    column = (column_t *)((byte *)patch + LONG(patch->columnofs[col]));
    desttop = (unsigned short *) (screen)+x;

    /*  step through the posts in a column */
    while (column->topdelta != 0xff )
    {
	source = (byte *)column + 3;
	dest = desttop + column->topdelta*SCREENWIDTH;
	count = column->length;
		
	while (count--)
	{
	    *dest = truecolor_palette[*source++];
	    dest += SCREENWIDTH;
	}
	column = (column_t *)(  (byte *)column + column->length + 4 );
    }
}

void
F_DrawPatchCol24
( int		x,
  patch_t*	patch,
  int		col )
{
    column_t*	column;
    byte*	source;
    byte*	dest;
    byte*	desttop;
    int		count;

	unsigned long	couleur;
	
    column = (column_t *)((byte *)patch + LONG(patch->columnofs[col]));
    desttop = screen+x*3;

    /*  step through the posts in a column */
    while (column->topdelta != 0xff )
    {
	source = (byte *)column + 3;
	dest = desttop + column->topdelta*SCREENWIDTH*3;
	count = column->length;
		
	while (count--)
	{
		couleur = truecolor_palette[*source++];

		*dest++ = couleur; 
		*dest++ = couleur >> 8; 
		*dest++ = couleur >> 16; 

		dest += (SCREENWIDTH*3)-3;
	}
	column = (column_t *)(  (byte *)column + column->length + 4 );
    }
}

/*
==================
=
= F_DemonScroll
=
==================
*/

void F_DemonScroll(void)
{
	byte *p1, *p2;
	static int yval = 0;
	static int nextscroll = 0;

	unsigned short *dest1;
	unsigned long *dest32;
	int i;
	byte *src,*dest;

	if(finalecount < nextscroll)
	{
		return;
	}
	p1 = W_CacheLumpName("FINAL1", PU_LEVEL);
	p2 = W_CacheLumpName("FINAL2", PU_LEVEL);

	if(finalecount < 70)
	{
		switch (pixel_size)
		{
			case 1:
				memcpy(screen, p1, SCREENHEIGHT*SCREENWIDTH);
				break;
			case 2:
				dest1=(unsigned short *) screen;
				src=p1;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
					*dest1++=truecolor_palette[*src++];
				break;
			case 3:
				dest=screen;
				src=p1;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
				{
					lighttable_t	couleur;

					couleur=truecolor_palette[*src++];

					*dest++=couleur;
					*dest++=couleur>>8;
					*dest++=couleur>>16;			
				}
				break;
			case 4:
				dest32=(unsigned long *) screen;
				src=p1;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
					*dest32++=truecolor_palette[*src++];
				break;
		}

		nextscroll = finalecount;
		return;
	}
	if(yval < 64000)
	{
		switch (pixel_size)
		{
			case 1:
				memcpy(screen, p2+SCREENHEIGHT*SCREENWIDTH-yval, yval);
				memcpy(screen+yval, p1, SCREENHEIGHT*SCREENWIDTH-yval);
				break;
			case 2:
				dest1=(unsigned short *) screen;
				src=p2+SCREENHEIGHT*SCREENWIDTH-yval;
				for (i=0;i<yval;i++)
					*dest1++=truecolor_palette[*src++];

				src=p1;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH-yval;i++)
					*dest1++=truecolor_palette[*src++];

				break;
			case 3:
				dest=screen;
				src=p2+SCREENHEIGHT*SCREENWIDTH-yval;
				for (i=0;i<yval;i++)
				{
					lighttable_t	couleur;

					couleur=truecolor_palette[*src++];

					*dest++=couleur;
					*dest++=couleur>>8;
					*dest++=couleur>>16;			
				}

/*				dest=screen+yval;*/
				src=p1;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH-yval;i++)
				{
					lighttable_t	couleur;

					couleur=truecolor_palette[*src++];

					*dest++=couleur;
					*dest++=couleur>>8;
					*dest++=couleur>>16;			
				}

				break;
			case 4:
				dest32=(unsigned long *) screen;
				src=p2+SCREENHEIGHT*SCREENWIDTH-yval;
				for (i=0;i<yval;i++)
					*dest32++=truecolor_palette[*src++];

				src=p1;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH-yval;i++)
					*dest32++=truecolor_palette[*src++];

				break;
		}

		yval += SCREENWIDTH;
		nextscroll = finalecount+3;
	}
	else
	{ /* else, we'll just sit here and wait, for now */
		switch (pixel_size)
		{
			case 1:
				memcpy(screen, p2, SCREENWIDTH*SCREENHEIGHT);
				break;
			case 2:
				dest1=(unsigned short *) screen;
				src=p2;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
					*dest1++=truecolor_palette[*src++];
				break;
			case 3:
				dest=screen;
				src=p2;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
				{
					lighttable_t	couleur;

					couleur=truecolor_palette[*src++];

					*dest++=couleur;
					*dest++=couleur>>8;
					*dest++=couleur>>16;			
				}
				break;
			case 4:
				dest32=(unsigned long *) screen;
				src=p2;
				for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
					*dest32++=truecolor_palette[*src++];
				break;
		}
	}
}

/*
==================
=
= F_DrawUnderwater
=
==================
*/

void F_DrawUnderwater(void)
{
	static boolean underwawa;
	extern boolean MenuActive;
	extern boolean askforquit;

	int i;
	unsigned short *dest1;
	byte *src,*dest;
	unsigned long *dest32;

	switch(finalestage)
	{
		case 1:
			if(!underwawa)
			{
				underwawa = true;
				memset(screen, 0, SCREENWIDTH*SCREENHEIGHT*pixel_size);
				I_SetPalette(W_CacheLumpName("E2PAL", PU_CACHE));

				src=W_CacheLumpName("E2END", PU_CACHE);

				switch (pixel_size)
				{
					case 1:
						memcpy(screen, src, SCREENWIDTH*SCREENHEIGHT);
						break;
					case 2:
						dest1=(unsigned short *) screen;
						for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
							*dest1++=truecolor_palette[*src++];
						break;
					case 3:
						dest=screen;
						for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
						{
							lighttable_t	couleur;

							couleur=truecolor_palette[*src++];

							*dest++=couleur;
							*dest++=couleur>>8;
							*dest++=couleur>>16;			
						}
						break;
					case 4:
						dest32=(unsigned long *) screen;
						for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
							*dest32++=truecolor_palette[*src++];
						break;
				}
			}
			paused = false;
			MenuActive = false;
			askforquit = false;

			break;
		case 2:
			src = W_CacheLumpName("TITLE", PU_CACHE);

			switch (pixel_size)
			{
				case 1:
					memcpy(screen, src, SCREENWIDTH*SCREENHEIGHT);
					break;
				case 2:
					dest1=(unsigned short *) screen;
					for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
						*dest1++=truecolor_palette[*src++];
					break;
				case 3:
					dest=screen;
					for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
					{
						lighttable_t	couleur;

						couleur=truecolor_palette[*src++];

						*dest++=couleur;
						*dest++=couleur>>8;
						*dest++=couleur>>16;			
					}
					break;
				case 4:
					dest32=(unsigned long *) screen;
					for (i=0;i<SCREENHEIGHT*SCREENWIDTH;i++)
						*dest32++=truecolor_palette[*src++];
					break;
			}

			/* D_StartTitle(); // go to intro/demo mode. */
	}
}



/*
=======================
=
= F_Drawer
=
=======================
*/

void F_Drawer(void)
{
	UpdateState |= I_FULLSCRN;
	if (!finalestage)
		F_TextWrite ();
	else
	{
		switch (gameepisode)
		{
			case 1:
				if(shareware)
					V_DrawRawScreen(W_CacheLumpName("ORDER", PU_CACHE));
				else
					V_DrawRawScreen(W_CacheLumpName("CREDIT", PU_CACHE));
				break;
			case 2:
				F_DrawUnderwater();
				break;
			case 3:
				F_DemonScroll();
				break;
			case 4: /*  Just show credits screen for extended episodes */
			case 5:
				V_DrawRawScreen(W_CacheLumpName("CREDIT", PU_CACHE));
				break;
		}
	}
}
