| 	Gestion du clavier sous interruptions

	.text

	.globl	_I_InitInterrupts
	.globl	_I_ShutdownInterrupts

	.globl	_I_UpdateSound
	.globl	_I_UpdateTime
	.globl	_I_UpdateJoypads

	.globl	_atari_CtrlCPressed
	.globl	_atari_clavier
	.globl	_joypads

	.globl	_atari_mouseb
	.globl	_atari_mousex
	.globl	_atari_mousey

	.globl	_atari_joystick

	.globl	_atari_joypad0
	.globl	_atari_joypad1

	.globl	_atari_curtime
	.globl	_atari_basetime

	.globl	_atari_sound
	.globl	_atari_dmabuffer
	.globl	_atari_sndlength
	.globl	_atari_calcbuffer

| -----	Installation des interruptions

_I_InitInterrupts:
	moveml	d0-d1/a0-a1,sp@-

	| Clear variables

	movel	0x4ba:w,_atari_basetime
	movel	_atari_basetime,_atari_curtime

	clrw	_atari_mouseb
	clrw	_atari_mousex
	clrw	_atari_mousey
	clrw	_atari_joystick
	clrl	_atari_joypad0
	clrl	_atari_joypad1
	clrw	_atari_CtrlCPressed

	clrw	sndbuf_flag
	
	| Clear keyboard table

	moveql	#127,d0
	lea	_atari_clavier,a0
Ikbd_bcl:
	clrb	a0@+
	dbra	d0,Ikbd_bcl

	| Init interrupts

	movew	#0x2700,sr

	movel	0xfffffa06:w,old_mfp
|	clrl	0xfffffa06:w

	movel	0x70:w,old_vbl
	movel	#vbl,0x70:w

	movel	0x118:w,old_ikbd
	movel	#ikbd,0x118:w
	bset	#6,0xfffffa09:w	| IERB
	bset	#6,0xfffffa15:w	| IMRB

	movel	0x134:w,old_timera

	tstl	_atari_sound
	beq	no_timera_sound
	movel	#timer_a,0x134:w
	bset	#5,0xfffffa07:w	| IERA
	bset	#5,0xfffffa13:w	| IMRA
	moveb	#8,0xfffffa19:w	| TACR Event count mode
	moveb	#1,0xfffffa1f:w	| TADR 1 event
no_timera_sound:

	moveb	#8,0xfffffc02:w

	movew	#0x2300,sr

	| Start sound interrupt

	tstl	_atari_sound
	beq	no_start_sound

	lea	0xffff8900:w,a0
	clrb	a0@(0x01)

	movel	_atari_sndlength,d1
	addl	d1,d1

	movel	_atari_dmabuffer,d0
	moveb	d0,a0@(0x07)
	rorw	#8,d0
	movel	d0,a0@(0x02)
	rorw	#8,d0

	addl	d1,d0

	moveb	d0,a0@(0x13)
	rorw	#8,d0
	movel	d0,a0@(0x0e)
	rorw	#8,d0

	moveb	#1,a0@(0x21)
	moveb	#3,a0@(0x01)
no_start_sound:

	| Interrupts done

	moveml	sp@+,d0-d1/a0-a1
	rts

| ----- Restauration ancienne routine

_I_ShutdownInterrupts:
	movew	#0x2700,sr

	tstl	_atari_sound
	beq	no_stop_sound
	clrb	0xffff8901:w
no_stop_sound:

	movel	old_mfp,0xfffffa06:w
	movel	old_ikbd,0x118:w
	movel	old_timera,0x134:w
	movel	old_vbl,0x70:w

ikbd_videbuffer:
	btst	#0,0xfffffc00:w
	beq	ikbd_finbuffer
	tstb	0xfffffc02:w
	bra	ikbd_videbuffer
ikbd_finbuffer:

	movew	#0x2300,sr
	rts

	.data
	.even
	.comm	old_ikbd,4*1
	.even
	.comm	old_mfp,4*1
	.even
	.comm	old_timera,4*1
	.even
	.comm	old_vbl,4*1

| -----	VBL
|	Update time and joypads

	.text
vbl:
	bsr	_I_UpdateTime
	
	tstl	_joypads
	beq	no_joypads
	bsr	_I_UpdateJoypads
no_joypads:

	jmp	@(old_vbl)@()
|	rte

| -----	Timer A interrupt : update sound

	.text
timer_a:

	| Swap sound buffer

	moveml	d0-d1/a0,sp@-

	movel	_atari_dmabuffer,d0
	movel	_atari_sndlength,d1
	addl	d1,d1
	notw	sndbuf_flag
	beq	firstbuf
	addl	d1,d0
firstbuf:
	movel	d0,_atari_calcbuffer

	lea	0xffff8900:w,a0
	moveb	d0,a0@(7)
	rorw	#8,d0
	movel	d0,a0@(2)
	rorw	#8,d0

	addl	d1,d0

	moveb	d0,a0@(0x13)
	rorw	#8,d0
	movel	d0,a0@(0x0e)

	moveml	sp@+,d0-d1/a0

	bclr	#5,0xfffffa0f:w
	movew	#0x2300,sr

	bsr	_I_UpdateSound

	rte

	.data
	.even
	.comm	_atari_calcbuffer,1*4
	.even
	.comm	sndbuf_flag,1*2

| ----------	Routine clavier

	.text

ikbd:
	moveml	d0-d1/a0,sp@-
	moveb	0xfffffc02:w,d0

	| paquet joystick ?
	
	cmpb	#0xff,d0
	beq	ikbd_yes_joystick

	| paquet souris ?

	cmpb	#0xf8,d0
	bmi	ikbd_no_mouse
	cmpb	#0xfc,d0
	bpl	ikbd_no_mouse

ikbd_yes_mouse:
	andw	#3,d0
	movew	d0,_atari_mouseb

	movel	#ikbd_mousex,0x118:w
	bra	ikbd_endit

ikbd_yes_joystick:
	movel	#ikbd_joystick,0x118:w
	bra	ikbd_endit

ikbd_no_mouse:
	moveb	d0,d1
	lea	_atari_clavier,a0
	andl	#0x7f,d1
	tas	d0
	spl	a0@(0,d1:w)
ikbd_fin:

	| Tester si Ctrl + C appuye

	tstb	_atari_clavier+0x1d	| Control ?
	beq	ikbd_noctrlc
	tstb	_atari_clavier+0x2e	| C ?
	beq	ikbd_noctrlc
	movew	#0xffff,_atari_CtrlCPressed
ikbd_noctrlc:

	| Fin interruption

ikbd_endit:
	moveml	sp@+,d0-d1/a0
	bclr	#6,0xfffffa11:w
	rte

ikbd_mousex:
	movel	d0,sp@-

	moveb	0xfffffc02:w,d0
	extw	d0
	addw	d0,_atari_mousex

	movel	sp@+,d0

	movel	#ikbd_mousey,0x118:w
	bclr	#6,0xfffffa11:w
	rte

ikbd_mousey:
	movel	d0,sp@-

	moveb	0xfffffc02:w,d0
	extw	d0
	subw	d0,_atari_mousey

	movel	sp@+,d0

	movel	#ikbd,0x118:w
	bclr	#6,0xfffffa11:w
	rte

ikbd_joystick:
	moveb	0xfffffc02:w,_atari_joystick+1

	movel	#ikbd,0x118:w
	bclr	#6,0xfffffa11:w
	rte

	.data
	
	.even
	.comm	_atari_clavier,128
	.even
	.comm	_atari_CtrlCPressed,2*1
	.even
	.comm	_atari_mousex,2*1
	.even
	.comm	_atari_mousey,2*1
	.even
	.comm	_atari_mouseb,2*1
	.even
	.comm	_atari_joystick,2*1
